function r2d(r)
	return r*57.2957795131
end

local mapMod = foundation.createMod();

mapMod:registerAssetId("maps/Danubius.png", "HEIGHT_MAP")
mapMod:registerAssetId("maps/material_mask_dd.png", "MATERIAL_MASK")
mapMod:registerAssetId("maps/coniferous_density.png", "CONIFEROUS_DENSITY_MAP")
mapMod:registerAssetId("maps/deciduous_density.png", "DECIDUOUS_DENSITY_MAP")
mapMod:registerAssetId("maps/berries_density.png", "BERRIES_DENSITY_MAP")
mapMod:registerAssetId("maps/rock_density.png", "ROCK_DENSITY_MAP")
mapMod:registerAssetId("maps/fish_density.png", "FISH_DENSITY_MAP")

-- Register Custom Map Delta Danubius
mapMod:register({
	DataType = "CUSTOM_MAP",
	Id = "MAP_DeltaDanubius_2019",
	HeightMap = "HEIGHT_MAP",
	MaterialMask = "MATERIAL_MASK",
	MinHeight = -3,
	MaxHeight = 60,
	VillagePathList = {
		{
			Entrance = { 1018, 0, 411 },
			Exit = { 1018, 0, 411 }
		},
		{
			Entrance = { 1019, 0, 30 },
			Exit = { 1019, 0, 30 }
		},
		{
			Entrance = { 900, 0, 1020 },
			Exit = { 900, 0, 1020 }
		},
		{
			Entrance = { 640, 0, 1020 },
			Exit = { 640, 0, 1020 }
		},
		{
			Entrance = { 4, 0, 900 },
			Exit = { 4, 0, 900 }
		},
		{
			Entrance = { 4, 0, 985 },
			Exit = { 1019, 0, 135 }
		}
	},
	SpawnList = {
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 805, 17, 510 },
			Orientation = { 0.0, math.randomf(90, 180), 0.0 }
		},

		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 370, 11, 150 },
			Orientation = { 0.0, math.randomf(-90, 180), 0.0 }
		},

		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 880, 4, 160 },
			Orientation = { 0.0, math.randomf(-90, 180), 0.0 }
		},

		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 450, 4, 678 },
			Orientation = { 0.0, 0.0, 0.0 }
		},

		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 715, 8, 260 },
			Orientation = { 0.0, math.randomf(90, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 738, 9, 258 },
			Orientation = { 0.0, 180, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 700, 10, 260 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 705, 6, 248 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 635, 4, 340 },
			Orientation = { 0.0, 0.0, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 640, 5, 293 },
			Orientation = { 0.0, r2d(-1.5), 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 650, 6, 323 },
			Orientation = { 0.0, -100, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 657, 10, 333 },
			Orientation = { 0.0, -90, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 657, 11, 317 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 654, 12, 300 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 650, 10, 295 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 650, 7, 311 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 660, 8, 347 },
			Orientation = { 0.0, r2d(-0.1), 0.0 }
		},
		
		{
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 330, 21, 183 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 333, 22, 166 },
			Orientation = { 0.0, 90, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 329, 22, 156 },
			Orientation = { 0.0, 180, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 327, 25, 169 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 328, 27, 166 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 326, 24, 176 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 320, 23, 166 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},

		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 590, 7, 797 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 592, 5, 785 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 572, 10, 809 },
			Orientation = { 0.0, 180, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 582, 11, 813 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 592, 8, 811 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 582, 9, 800 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},

		{
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 350, 21, 650 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 344, 23, 660 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},

		{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 890, 12, 210 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},

		{
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 250, 4, 522 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 240, 6, 510 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 251, 5	, 511 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 890, 30, 315 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 892, 31, 323 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		}
	},
	DensitySpawnList = {
		{
			-- Create forest of Deciduous trees and a few pine
			DensityMap = "DECIDUOUS_DENSITY_MAP",
			Density = 0.90,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_TREE_POPLAR" },
					RandomWeight = 8,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				},
				{
					PrefabList = { "PREFAB_TREE_OAK" },
					RandomWeight = 0.1,
					OffsetSizeRange = {
						Min = 0.9,
						Max = 1.9
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.9,
						Max = 1.9
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				},
				{
					PrefabList = { "PREFAB_TREE_SYCAMORE" },
					RandomWeight = 8,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				},
				{
					PrefabList = { "PREFAB_TREE_PINE" },
					RandomWeight = 1,
					OffsetSizeRange = {
						Min = 0.15,
						Max = 0.45
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.7,
						Max = 1
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
			{
			-- Create forest of Pine Trees
			DensityMap = "CONIFEROUS_DENSITY_MAP",
			Density = 0.95,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_TREE_PINE" },
					RandomWeight = 0.1,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			-- Create forest of berry bushes
			DensityMap = "BERRIES_DENSITY_MAP",
			Density = 1,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_RESOURCE_BERRIES" },
					RandomWeight = 0.1,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			-- Create rock outcrops - stone resource
			DensityMap = "ROCK_DENSITY_MAP",
			Density = 1,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_RESOURCE_ROCK" },
					RandomWeight = 0.1,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			-- Create fish shoals
			DensityMap = "FISH_DENSITY_MAP",
			Density = 1,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_RESOURCE_FISH" },
					RandomWeight = 0.1,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		}
	}
})